package com.rodriguez.noticias;

import android.content.Intent;
import android.net.Uri;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.method.ScrollingMovementMethod;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

public class ActividadNoticia extends AppCompatActivity {
    private TextView noticia_titular;
    private TextView noticia_fecha;
    private TextView noticia_cuerpo;
    private TextView noticia_periodico;
    private String noticia_url;
    private static AlmacenNoticias almacen;
    private Noticia noticia;
    private Bundle extras;
    String tipo;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.actividad_noticia);
        noticia_titular = (TextView) findViewById(R.id.noticia_titular);
        noticia_fecha   = (TextView) findViewById(R.id.noticia_fecha);
        noticia_cuerpo  = (TextView) findViewById(R.id.noticia_cuerpo);
        noticia_periodico = (TextView) findViewById(R.id.noticia_periodico);
        extras = getIntent().getExtras();
        noticia_titular.setText(extras.getString("titular"));
        noticia_fecha.setText(extras.getString("fecha"));
        noticia_cuerpo.setText(extras.getString("cuerpo"));
        noticia_periodico.setText(extras.getString("periodico"));
        noticia_url = extras.getString("url");
        noticia_cuerpo.setMovementMethod(new ScrollingMovementMethod());
        tipo= extras.getString("tipo");

        almacen = new AlmacenNoticiasSQLite(this);
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu){
        if (tipo.equals("fav")){
            getMenuInflater().inflate(R.menu.menu_noticia_fav, menu);
        }else {
            getMenuInflater().inflate(R.menu.menu_noticia, menu);
        }
        return true;
    }

    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        if (id == R.id.action_favoritos) {
            lanzarFavoritos(null);
            return true;
        }
        if (id == R.id.action_completa) {
            lanzarUrl(null);
            return true;
        }
        if (id == R.id.action_acercaDe) {
            lanzarAcercaDe(null);
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    public void lanzarFavoritos(View view) {
        String titular = extras.getString("titular");
        String fecha = extras.getString("fecha");
        String cuerpo = extras.getString("cuerpo");
        String periodico = extras.getString("periodico");
        String url = extras.getString("url");
        if (tipo.equals("fav"))
        {
            almacen.borrarNoticia(periodico,titular,fecha,cuerpo,url);
            Toast.makeText(this,"Noticia eliminada de favoritos",Toast.LENGTH_LONG).show();
            finish();
        }else{
            noticia = new Noticia(periodico,titular,fecha,cuerpo,url);
            almacen.guardarNoticias(noticia);
            Toast.makeText(this,"Noticia añadida a favoritos",Toast.LENGTH_LONG).show();
        }
    }

    public void lanzarAcercaDe(View view) {
        Intent i = new Intent(this,AcercaDeActivity.class);
        startActivity(i);
    }

    public void lanzarUrl(View view) {
        if (!noticia_url.isEmpty() && noticia_url != "" && noticia_url != null){
            Uri direccion = Uri.parse(noticia_url);
            Intent intent = new Intent(Intent.ACTION_VIEW,direccion);
            startActivity(intent);
            Toast.makeText(this,"Lanzamos URL:" + noticia_url+":",Toast.LENGTH_LONG).show();
        }else{
            Toast.makeText(this,"No se ha podido recuperar la URL de la noticia original.",Toast.LENGTH_LONG).show();
        }
    }
}
