package com.rodriguez.noticias;

import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.Icon;
import android.os.Build;
import android.support.annotation.RequiresApi;
import android.support.v4.app.FragmentTabHost;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.AttributeSet;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.List;

public class ActividadPrincipal extends AppCompatActivity {

    private FragmentTabHost tabHost;
    private int miPagina;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.actividad_principal);
        Drawable ic_actualidad = getResources().getDrawable(R.drawable.ic_actualidad);
        Drawable ic_deporte = getResources().getDrawable(R.drawable.ic_deportes);
        Drawable ic_tecnologia = getResources().getDrawable(R.drawable.ic_deportes);

        tabHost = (FragmentTabHost) findViewById(android.R.id.tabhost);
        tabHost.setup(this,getSupportFragmentManager(),android.R.id.tabcontent);
        tabHost.addTab(tabHost.newTabSpec("periodicos1").setIndicator(getResources().getString(R.string.Seccion1),ic_actualidad),
                Periodicos1.class,null);
        tabHost.addTab(tabHost.newTabSpec("periodicos2").setIndicator(getResources().getString(R.string.Seccion2),ic_deporte),
                Periodicos2.class,null);
        tabHost.addTab(tabHost.newTabSpec("periodicos3").setIndicator(getResources().getString(R.string.Seccion3),ic_tecnologia),
                Periodicos3.class,null);
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    protected void onRestart() {
        super.onRestart();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }

    @Override
    protected void onStop() {
        super.onStop();
    }

    public void lanzaNoticias(View view) {
        miPagina = Integer.parseInt((String) view.getTag());
        Intent intent = new Intent(this,TitularesActivity.class);
        intent.putExtra("link",miPagina);
        intent.putExtra("tipo", "not");
        startActivity(intent);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu){
        getMenuInflater().inflate(R.menu.menu_main,menu);
        return true;
    }

    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        if (id == R.id.action_favoritos) {
            lanzarFavoritos(null);
            return true;
        }
        if (id == R.id.action_acercaDe) {
            lanzarAcercaDe(null);
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    public void lanzarFavoritos(View view) {
        Intent intent = new Intent(this,TitularesActivity.class);
        intent.putExtra("tipo", "fav");
        startActivity(intent);
    }

    public void lanzarAcercaDe(View view) {
        Intent i = new Intent(this,AcercaDeActivity.class);
        startActivity(i);
    }
}
