package com.rodriguez.noticias;

import android.content.Context;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import java.util.ArrayList;

/**
 * Created by miria on 01/12/2016.
 */

public class AdaptadorNoticias extends RecyclerView.Adapter<AdaptadorNoticias.ViewHolder> {
    private LayoutInflater inflador;
    private ArrayList<Noticia> lista = new ArrayList<Noticia>();
    protected View.OnClickListener onClickListener;

    public AdaptadorNoticias(Context context, ArrayList<Noticia> lista) {
        this.lista = lista;
        inflador = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    }

    @Override
    public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        View v = inflador.inflate(R.layout.titular, parent, false);
        v.setOnClickListener(onClickListener);
        return new ViewHolder(v);
    }

    @Override
    public void onBindViewHolder(ViewHolder holder, int i) {
        holder.titTitulo.setText(lista.get(i).getTitular());
    }

    @Override
    public int getItemCount() {
        return lista.size();
    }

    public class ViewHolder extends RecyclerView.ViewHolder {
        public TextView titTitulo;

        ViewHolder(View itemView) {
            super(itemView);
            titTitulo = (TextView) itemView.findViewById(R.id.titular_titular);
        }
    }

    public void setOnItemClickListener(View.OnClickListener onClickListener) {
        this.onClickListener = onClickListener;
    }
}
