package com.rodriguez.noticias;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import java.util.ArrayList;

/**
 * Created by miria on 15/11/2016.
 */

public class AlmacenNoticiasSQLite extends SQLiteOpenHelper
        implements AlmacenNoticias{

    public AlmacenNoticiasSQLite(Context context) {
        super(context, "noticias", null, 1);
    }

    @Override
    public void onCreate(SQLiteDatabase db) {
        db.execSQL("CREATE TABLE noticias ("+
                "_id INTEGER PRIMARY KEY AUTOINCREMENT, "+
                "periodico TEXT, titular TEXT, cuerpo TEXT, fecha TEXT, url TEXT)");
    }

    @Override
    public void onUpgrade(SQLiteDatabase db,
                                    int oldVersion, int newVersion) {
    // En caso de una nueva versión habría que actualizar las tablas
    }

    public void guardarNoticias(Noticia noticia) {
        SQLiteDatabase db = getWritableDatabase();
        String periodico = noticia.getPeriodico();
        String titular = noticia.getTitular();
        String cuerpo = noticia.getCuerpo();
        String fecha = noticia.getFecha();
        String url = noticia.getUrl();
        db.execSQL("INSERT INTO noticias VALUES ( null, '"
                +periodico+"', '"
                +titular+"', '"
                +cuerpo+"', '"
                +fecha+"', '"
                +url+"')");
        db.close();
    }

    public ArrayList<Noticia> listaNoticias(){
        ArrayList<Noticia> result = new ArrayList<Noticia>();
        SQLiteDatabase db = getReadableDatabase();
        String[] CAMPOS = {"periodico","titular","cuerpo","fecha","url"};
        Cursor cursor=db.query("noticias", CAMPOS, null, null,
                null, null, "fecha DESC", null);
        while (cursor.moveToNext()){
            String periodico = cursor.getString(0);
            String titular = cursor.getString(1);
            String cuerpo = cursor.getString(2);
            String fecha = cursor.getString(3);
            String url = cursor.getString(4);
            Noticia miNoticia = new Noticia(periodico,titular,fecha,cuerpo,url);
            result.add(miNoticia);
        }
        cursor.close();
        db.close();
        return result;
    }

    public void borrarNoticia(String periodico,String titular,String fecha,String cuerpo,String url){
        SQLiteDatabase bd = getWritableDatabase();
        bd.execSQL("DELETE FROM noticias WHERE periodico = '" + periodico
                                      + "' AND titular = '" + titular
                                      + "' AND cuerpo = '" + cuerpo
                                      + "' AND fecha = '" + fecha
                                      + "' AND url = '" + url + "'"
        );
        bd.close();
    }
}