package com.rodriguez.noticias;

import android.util.Log;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import java.util.ArrayList;

/**
 * Created by Daniel on 24/09/2015.
 */
public class SAXParserHandler extends DefaultHandler {
    public ArrayList<Noticia> noticias;
    Noticia noticiaActual;
    StringBuilder texto;
    final Character comilla = 0x0027;

    @Override
    public void startDocument() throws SAXException {
        noticias = new ArrayList<Noticia>();
        texto = new StringBuilder();
    }

    @Override
    public void startElement(String uri, String localName, String qName, Attributes attributes) throws SAXException {
        if (localName.equals("item")) {
            noticiaActual = new Noticia();
        }
        texto.setLength(0);
    }

    @Override
    public void endElement(String uri, String localName, String qName) throws SAXException {
        if (noticiaActual != null) {
            if (localName.equals("title")) {
                String miTitular= texto.toString();
                noticiaActual.setTitular(limpiarTexto(miTitular));
            } else if (localName.equals("description")) {
                String miTexto= texto.toString();
                noticiaActual.setCuerpo(limpiarTexto(miTexto));
            } else if (localName.equals("pubDate")) {
                noticiaActual.setFecha(texto.toString());
            } else if (localName.equals("link")) {
                noticiaActual.setUrl(texto.toString());
            } else if (localName.equals("item")) {
                noticias.add(noticiaActual);
                noticiaActual = null;
            }
        }
   }

    @Override
    public void characters(char[] ch, int start, int length) throws SAXException {
        texto.append(ch,start,length);
    }
    public String limpiarTexto(String miTexto){
        String salida = new String();
        boolean guardar = true;
        for (int i = 0;i<miTexto.length();i++){
            if(miTexto.charAt(i)=='<'){
                guardar = false;
            }else{
                if (guardar) {
                    if(miTexto.charAt(i)!= comilla) {
                        salida += miTexto.charAt(i);
                    }
                }else{
                    if(miTexto.charAt(i)=='>'){
                        guardar = true;
                    }
                }
            }
        }
        return salida;
    }
}
