package com.rodriguez.noticias;

import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import org.xml.sax.SAXException;

import java.io.IOException;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

public class TitularesActivity extends AppCompatActivity {

    private final String[] paginas = {
            "http://ep00.epimg.net/rss/elpais/portada.xml",
            "http://www.infolibre.es/index.php/mod.portadas/mem.rss",
            "http://www.europapress.es/rss/rss.aspx",
            "http://www.abc.es/rss/feeds/abc_Deportes.xml",
            "http://as.com/rss/diarioas/portada.xml",
            "http://www.europapress.es/rss/rss.aspx?ch=67",
            "http://www.abc.es/rss/feeds/abc_Tecnologia.xml",
            "http://www.vidaextra.com/categoria/vidaextra/rss2.xml",
            "http://www.technologyreview.es/rss/feeds/rss.aspx?from=feedstr"};
    private final String[] periodicos = {
            "ElPais",
            "InfoLibre",
            "Europapress-Actualidad",
            "ABC-Deportes",
            "AS",
            "Europapress-Deportes",
            "ABC-Tecnologia",
            "Vidaextra",
            "MITTechnologyReview"};
    private ArrayList<Noticia> listaNoticias;
    private RecyclerView recyclerView;
    private RecyclerView.LayoutManager layoutManager;
    private AdaptadorNoticias adaptador;
    private String miPeriodico= "";
    public static AlmacenNoticias almacen;
    private String tipo;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.actividad_titulares);
    }

    @Override
    protected void onResume() {
        super.onResume();
        Bundle extras = getIntent().getExtras();
        tipo= extras.getString("tipo");
        if(tipo.equals("fav")){
            almacen = new AlmacenNoticiasSQLite(this);
            listaNoticias = almacen.listaNoticias();
            recyclerView = (RecyclerView) findViewById(R.id.recycler_view);
            adaptador = new AdaptadorNoticias(TitularesActivity.this, listaNoticias);
            recyclerView.setAdapter(adaptador);
            layoutManager = new LinearLayoutManager(TitularesActivity.this);
            recyclerView.setLayoutManager(layoutManager);
            adaptador.setOnItemClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    int pos = recyclerView.getChildAdapterPosition(v);
                    String s = listaNoticias.get(pos).toString();
                    Intent intent = new Intent(getApplicationContext(),ActividadNoticia.class);
                    intent.putExtra("titular",listaNoticias.get(pos).getTitular());
                    intent.putExtra("fecha",listaNoticias.get(pos).getFecha());
                    intent.putExtra("cuerpo",listaNoticias.get(pos).getCuerpo());
                    intent.putExtra("periodico",listaNoticias.get(pos).getPeriodico());
                    intent.putExtra("url",listaNoticias.get(pos).getUrl());
                    intent.putExtra("tipo",tipo);
                    startActivity(intent);
                }
            });
            adaptador.notifyDataSetChanged();
        }else{
            int miPagina = extras.getInt("link");
            miPeriodico = periodicos[miPagina];
            new leeNoticias().execute(paginas[miPagina]);
        }
    }

    class leeNoticias extends AsyncTask<String,Void,ArrayList<Noticia>> {
        @Override
        protected void onPreExecute() {

        }

        @Override
        protected void onPostExecute(ArrayList<Noticia> noticias) {
            Iterator itrNot = noticias.iterator();
            listaNoticias = new ArrayList<Noticia>();
            while (itrNot.hasNext()){
                Noticia miNoticia = (Noticia) itrNot.next();
                miNoticia.setPeriodico(miPeriodico);
                listaNoticias.add(miNoticia);
            }
            recyclerView = (RecyclerView) findViewById(R.id.recycler_view);
            adaptador = new AdaptadorNoticias(TitularesActivity.this, listaNoticias);
            recyclerView.setAdapter(adaptador);
            layoutManager = new LinearLayoutManager(TitularesActivity.this);
            recyclerView.setLayoutManager(layoutManager);
            adaptador.setOnItemClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    int pos = recyclerView.getChildAdapterPosition(v);
                    String s = listaNoticias.get(pos).toString();
                    Intent intent = new Intent(getApplicationContext(),ActividadNoticia.class);
                    intent.putExtra("titular",listaNoticias.get(pos).getTitular());
                    intent.putExtra("fecha",listaNoticias.get(pos).getFecha());
                    intent.putExtra("cuerpo",listaNoticias.get(pos).getCuerpo());
                    intent.putExtra("periodico",listaNoticias.get(pos).getPeriodico());
                    intent.putExtra("url",listaNoticias.get(pos).getUrl());
                    intent.putExtra("tipo",tipo);
                    startActivity(intent);
                }
            });
            adaptador.notifyDataSetChanged();
        }

        @Override
        protected void onProgressUpdate(Void... values) {

        }

        @Override
        protected ArrayList<Noticia> doInBackground(String... params) {

            ArrayList<Noticia> noticias = new ArrayList<>();
            try {
                SAXParserFactory factory = SAXParserFactory.newInstance();
                SAXParser parser = factory.newSAXParser();
                SAXParserHandler handler = new SAXParserHandler();
                parser.parse(params[0],handler);
                noticias = handler.noticias;
            } catch (ParserConfigurationException e) {
                e.printStackTrace();
                Noticia noticiaActual = new Noticia();
                noticiaActual.setTitular("Error al cargar la página.");
                noticiaActual.setFecha("");
                noticiaActual.setCuerpo("Por favor, intenta acceder de nuevo más tarde.");
                noticiaActual.setUrl("");
                noticias.add(noticiaActual);
            } catch (SAXException e) {
                e.printStackTrace();
                Noticia noticiaActual = new Noticia();
                noticiaActual.setTitular("Error al transformar la página.");
                noticiaActual.setFecha("");
                noticiaActual.setCuerpo("Por favor, intenta acceder de nuevo más tarde.");
                noticiaActual.setUrl("");
                noticias.add(noticiaActual);
            } catch (IOException e) {
                e.printStackTrace();
                Noticia noticiaActual = new Noticia();
                noticiaActual.setTitular("No se tiene acceso a internet.");
                noticiaActual.setFecha("");
                noticiaActual.setCuerpo("Para acceder a las noticias de la página en cuestion, por favor, revise su conexión a Internet.");
                noticiaActual.setUrl("");
                noticias.add(noticiaActual);
            } catch(Exception e){
                e.printStackTrace();
                Noticia noticiaActual = new Noticia();
                noticiaActual.setTitular("Error general al cargar la página.");
                noticiaActual.setFecha("");
                noticiaActual.setCuerpo("Por favor, intenta acceder de nuevo más tarde.");
                noticiaActual.setUrl("");
                noticias.add(noticiaActual);
            }
            return noticias;
        }
    }
}